﻿Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Threading
Imports System.ComponentModel
Imports System.Speech.Synthesis







Public Class Form1

    Inherits System.Windows.Forms.Form


   


    'Declare MAP27 DLL functions
    Declare Ansi Function SETCALLBACK Lib ".\SrmDrvr.dll" (ByVal myByte As Byte, ByVal fP As MyDelegateIncomingHandler) As Byte
    Declare Ansi Function SENDRADIOMESSAGE Lib ".\SrmDrvr.dll" (ByVal message As IntPtr) As Byte
    Declare Ansi Function COPYMESSAGE Lib ".\SrmDrvr.dll" (ByRef dest As Byte, ByRef src As Byte) As Byte

    Public Shared currentchannel, radiocomport, outputcomport, gpsspeed, gpscomport As Integer
    Public Shared pttflag, gpsenabled As Boolean
    Public Shared cos, ptt As String
    Public Shared pttbackcolour As Color
    Public Shared degrees, minutes, seconds As Double

    Dim WithEvents spvoice As New SpeechSynthesizer


    Public Shared tempvoice As String


    Public Shared latitudesp, longitudesp, timesp, altitudesp, speedsp, headingsp, satssp As String
    Public Shared hour, min, secs, beacontext As String
    Public Shared speechenabled, pttactive, nobeacon, flag, timeoutenabled, firstrunflag, tempenabled As Boolean
    Public Shared beacontime, timeout As Integer
    Public Shared gpslblback As Color






    Dim proc As New Process

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        quit()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

    End Sub

  





    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        Try
            gpsserialport.Close()

        Catch ex As Exception

        End Try

        Dim rd(100) As Byte

        gpslblback = gpslbl.BackColor


        pttbackcolour = pttbutton.BackColor
        nobeacon = False
        flag = False
        ffsklabel.Enabled = False


        radiocomport = GetSetting("SRM9000", "main", "radiocomport", "1")
        outputcomport = GetSetting("SRM9000", "main", "outputcomport", "9")
        senddatacheck.Checked = GetSetting("SRM9000", "main", "senddatacheck", False)
        cos = GetSetting("SRM9000", "main", "cos", "RTS")
        ptt = GetSetting("SRM9000", "main", "ptt", "CTS")
        gpscomport = GetSetting("SRM9000", "main", "gpscomport", 3)

        timeout = GetSetting("SRM9000", "main", "timeout", 10)
        timeoutenabled = GetSetting("SRM9000", "main", "timeoutenabled", True)
        gpsspeed = GetSetting("SRM9000", "main", "gpsspeed", 9600)

        speechenabled = GetSetting("SRM9000", "main", "speechenabled", False)
        beacontime = GetSetting("SRM9000", "main", "beacontime", 3)
        pttactive = GetSetting("SRM9000", "main", "pttactive", False)
        beacontext = GetSetting("SRM9000", "main", "beacontext", "")
        options.ffskenabled.Checked = GetSetting("SRM9000", "main", "ffskenabled", False)
        options.ffsktext.Text = GetSetting("SRM9000", "main", "ffsktext", "")


        If cos = "RTS" Then rtsbtn.Checked = True Else dtrbtn.Checked = True
        If ptt = "CTS" Then ctsbutton.Checked = True Else DSRbox.Checked = True
        If gpsspeed = 4800 Then
            btn4800.Checked = True
            gpsserialport.BaudRate = 4800

        Else
            btn9600.Checked = True
            gpsserialport.BaudRate = 9600

        End If

        gpsserialport.PortName = "COM" + Convert.ToString(gpscomport)




        gpsenabled = GetSetting("SRM9000", "main", "gpsenabled", False)

        tempenabled = GetSetting("SRM9000", "main", "tempenabled", False)

        firstrunflag = True




        If gpsenabled = False Then
            enablegps.Checked = False
        Else

            gpslbl.Enabled = True
            enablegps.Checked = True
            If gpsserialport.IsOpen = False Then
                Try
                    gpsserialport.Open()
                Catch ex As Exception
                    MsgBox("GPS com port is not available", MsgBoxStyle.Critical)
                    gpslbl.Enabled = False
                    enablegps.Checked = False
                End Try
            End If
        End If






        radiocom.Text = radiocomport
        outcombox.Text = outputcomport

        SetupOptions.ComPort = Convert.ToInt16(radiocomport)

        SetupOptions.RadioMode = PMR
        SetupOptions.DebugMode = DEBUG_ON
        StartMap27Dll()

        If senddatacheck.Checked = True Then

            Try
                outputserialport.PortName = "COM" + Convert.ToString(outputcomport)
                outputserialport.Open()

            Catch ex As Exception
                MsgBox("Can't open output com port")
                senddatacheck.Checked = False

            End Try


        End If
        Timer1.Enabled = True
        Timer1.Interval = (beacontime * 60) * 1000

        Timer1.Start()



    End Sub



#Region " MAP27 DLL Interface "

    'This application uses the TMC Radio MAP27 DLL.
    'While this DLL was easy to integrate in VB6 Applications and
    'other C++ applications, for VB.NET, some software acrobatics 
    'is required.

    Public Function IncomingHandler(ByVal message As IntPtr) As Byte
        'Receive serial message from radio

        Dim RadioMessage(256) As Byte
        Dim i As Integer = 0

        Dim RxSerialStrLength As Integer
        Dim RxSerialHexString As String

        RxSerialHexString = 0
        Marshal.Copy(message, RadioMessage, 0, 256)

        '-----------------------------------------------------------
        'If debug mode is on, then display the received serial message.




        If RadioMessage(2) = &H9B Then statusupdate(RadioMessage) ' call status update



        If SetupOptions.DebugMode = DEBUG_ON Then

            'Prepare received binary serial data as string of hex characters
            'then display character string in the dispatcher list.
            'NOTE: If messages have the same time, (ie arrive within 1 second), 
            '      then the order of received messages may not be displayed 
            '      correctly in the list.  

            RxSerialStrLength = RadioMessage(0)
            For i = 0 To RxSerialStrLength
                RxSerialHexString += " " + RadioMessage(i).ToString("X2")
            Next

            'Display received hex string in Dispatcher List

        End If

        '-----------------------------------------------------------
        'Check if Link-Established message received

        If RadioMessage(1) = 8 Then
            If RadioMessage(2) = 0 Then
                'Link Established.
                SerialLink = LINK_ESTABLISHED

                'When DLL establishes a link with the radio, we should
                'immediately send a DTE login message to the radio.

                If SetupOptions.RadioMode = TRUNK Then
                    'Get Trunk Dispatcher radio's own Prefix and IBI
                    RadioMessage(0) = CByte(&H2)  'Message Length
                    RadioMessage(1) = CByte(&HB0) 'Command: Radio Interrogation 
                    RadioMessage(2) = CByte(&H1)  'Reason: Request Numbering Information
                Else
                    'PMR DTE Login Command
                    'So the radio 'knows' it is connected to the dispatcher.
                    RadioMessage(0) = CByte(&H7)  'Message Length
                    RadioMessage(1) = CByte(&H0)  'PMR Message
                    RadioMessage(2) = CByte(&HB5) 'Command: Console Type
                    RadioMessage(3) = CByte(&H0)
                    RadioMessage(4) = CByte(&H0)
                    RadioMessage(5) = CByte(&H0)
                    RadioMessage(6) = CByte(&H1)
                    RadioMessage(7) = CByte(&H6)  'External MAP27 serial DTE Device
                End If
                SendMessage(RadioMessage)

            ElseIf RadioMessage(2) = 1 Then
                'Link Lost or not established
                SerialLink = LINK_LOST
            End If
        Else
            'Display received serial message

            'RaiseEvent MessageReceived()
        End If

    End Function

    Public Delegate Function MyDelegateIncomingHandler(ByVal message As IntPtr) As Byte
    <MarshalAs(UnmanagedType.FunctionPtr)> Private Callback As MyDelegateIncomingHandler

    Public Sub StartMap27Dll()
        Dim ret As Byte
        Dim ErrorReason As String = ""
        Dim Port As Byte

        Port = CByte(SetupOptions.ComPort)
        Callback = New MyDelegateIncomingHandler(AddressOf IncomingHandler)
        ret = SETCALLBACK(Port, Callback)

        If ret > 0 Then
            'Error communicating with MAP27 DLL, so show
            'reason.
            Select Case ret
                Case 1
                    ErrorReason = "Com Port already in use"
                Case 2
                    ErrorReason = "Com Port doesn't exist"
                Case 3 To 5
                    ErrorReason = "Unable to allocate MAP27 DLL thread"
            End Select
            MessageBox.Show("MAP27 DLL Error." + vbCrLf + ErrorReason, "Warning")

        End If



    End Sub

    Public Sub SendMessage(ByVal message() As Byte)

        'Send serial data message to radio
        Dim ret As Byte
        Dim j As Integer

        Dim copyOfMsg As IntPtr
        Dim TxSerialStrLength As Integer
        Dim TxSerialHexString As String

        TxSerialHexString = 0
        'Check dispatcher radio is connected and switched on
        If SerialLink = LINK_LOST Then
            MessageBox.Show("Cannot send Message." + vbCrLf + _
            "No serial link with radio." + vbCrLf + vbCrLf + _
            " - Check correct COM Port Selected." + vbCrLf + _
            " - Check serial cable between PC and Radio." + vbCrLf + _
            " - Check Radio is switched on." + vbCrLf + vbCrLf, "Warning")
            Return
        End If

        '-----------------------------------------------------------
        'If debug mode is on, then display serial message that is about to be sent.

        If SetupOptions.DebugMode = DEBUG_ON Then
            'Prepare binary serial data as string of hex characters
            TxSerialStrLength = message(0)
            For j = 0 To TxSerialStrLength
                TxSerialHexString += " " + message(j).ToString("X2")
            Next

            'Now display hex string in Dispatcher List


        End If

        '-----------------------------------------------------------
        'Send the Message

        copyOfMsg = Marshal.AllocHGlobal(256)
        Marshal.Copy(message, 0, copyOfMsg, 256)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)

    End Sub

    Public Event MessageReceived()





#End Region

    Private Sub pttbutton_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles pttbutton.KeyDown
        If e.KeyCode = Keys.Space Then
            PTTDOWN()
        End If
    End Sub

    Private Sub pttbutton_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles pttbutton.KeyUp
        If e.KeyCode = Keys.Space Then PTTUP()
    End Sub












    Private Sub Button2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pttbutton.MouseDown

        PTTDOWN()


    End Sub

    Private Sub PTTDOWN()

        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr

        If timeoutenabled = True Then
            timeouttimer.Start()
        End If



        If pttactive = True Then nobeacon = True


        

        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = &HBB        'SubType = SET_PTT
        sendPkt(3) = &H82


        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)


        If (ret = 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send
        End If

    End Sub



    Private Sub PTTUP()

        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        nobeacon = False

        If beaconlbl.Enabled = False Then


            'sendPkt is initialised by VB to 0 so we only set non-zero values
            sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
            sendPkt(2) = &HBB       'SubType = SET_PTT_OFF
            sendPkt(3) = 0



            copyOfMsg = Marshal.AllocHGlobal(8)
            Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
            ret = SENDRADIOMESSAGE(copyOfMsg)
            Marshal.FreeHGlobal(copyOfMsg)


            If (ret = 1) Then '1 = send buffer is full (size is 2048 in DLL)
                'Error, unable to send
            End If
        End If

    End Sub



    Private Sub Button2_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pttbutton.MouseUp
        PTTUP()

    End Sub







    Public Sub statusupdate(ByVal rxbyte() As Byte)
        Dim messagelength
        Dim hexstring, binstring2, binstring1, channumberhex As String
        Dim sigstrength As Integer
        hexstring = ""
        messagelength = rxbyte(0)
        For i = 0 To messagelength

            hexstring += " " + rxbyte(i).ToString("X2")
        Next




        'debugbox.AppendText(hexstring + vbCrLf)

        Select Case rxbyte(3)

            Case 0
                'signal
                binstring1 = Convert.ToString(rxbyte(4), 2).PadLeft(8, "0"c)
                binstring2 = Convert.ToString(rxbyte(5), 2).PadLeft(8, "0"c)
                sigstrength = rxbyte(6)
                channumberhex = Hex(rxbyte(7)) + Hex(rxbyte(8))
                sigstrength = sigstrength - 30
                If sigstrength < 0 Then sigstrength = 0
                chanbox.Text = Convert.ToInt32(channumberhex, 16)
                currentchannel = Convert.ToInt32(channumberhex, 16)
                smeter.Level = sigstrength

                ' carrier detect
                If Mid(binstring2, 8, 1) = "0" Then carrierdet.Enabled = False
                If Mid(binstring2, 8, 1) = "1" Then carrierdet.Enabled = True
                ' valid signal
                If Mid(binstring2, 1, 1) = "0" Then
                    validsig.Enabled = False

                    If senddatacheck.Checked = True Then
                        If rtsbtn.Checked = True Then
                            outputserialport.RtsEnable = False
                        Else
                            outputserialport.DtrEnable = False
                        End If
                    End If
                End If


                If Mid(binstring2, 1, 1) = "1" Then
                    validsig.Enabled = True

                    If senddatacheck.Checked = True Then
                        If rtsbtn.Checked = True Then
                            outputserialport.RtsEnable = True
                        Else
                            outputserialport.DtrEnable = True
                        End If
                    End If
                End If


                ' CTCSS signal
                If Mid(binstring2, 7, 1) = "0" Then ctcssmute.Enabled = False
                If Mid(binstring2, 7, 1) = "1" Then ctcssmute.Enabled = True
                ' TX signal
                If Mid(binstring2, 4, 1) = "0" Then
                    txlabel.Enabled = False
                    pttbutton.BackColor = pttbackcolour
                    NotifyIcon1.Icon = System.Drawing.Icon.ExtractAssociatedIcon("ProgSRM3.ico")
                    NotifyIcon1.Text = "SRM9000 Controller"



                End If

                If Mid(binstring2, 4, 1) = "1" Then
                    txlabel.Enabled = True
                    pttbutton.BackColor = Color.Red
                    NotifyIcon1.Icon = System.Drawing.Icon.ExtractAssociatedIcon("warning.ico")
                    NotifyIcon1.Text = "RADIO IS IN TRANSMIT"

                    If lowpowerlbl.Enabled = True Then
                        smeter.Level = 10
                    Else
                        smeter.Level = 20

                    End If

                End If

                ' Low Power
                If Mid(binstring1, 4, 1) = "0" Then lowpowerlbl.Enabled = False
                If Mid(binstring1, 4, 1) = "1" Then lowpowerlbl.Enabled = True

        End Select

        'check for Carrier detect


    End Sub



    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub validsig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles validsig.Click

    End Sub


    Private Sub quit()




        Try
            outputserialport.Close()

        Catch ex As Exception

        End Try

        Try
            gpsserialport.Close()


        Catch ex As Exception

        End Try


        If rtsbtn.Checked Then SaveSetting("SRM9000", "main", "cos", "RTS") Else SaveSetting("SRM9000", "main", "cos", "DTR")
        If ctsbutton.Checked Then SaveSetting("SRM9000", "main", "ptt", "CTS") Else SaveSetting("SRM9000", "main", "ptt", "DSR")


        beaconlbl.Enabled = False

        PTTUP()

        spvoice.SpeakAsyncCancelAll()


        Application.Exit()


    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        quit()
    End Sub

    Private Sub monitorbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles monitorbtn.Click
        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 195       'SubType = execute function
        sendPkt(3) = 3


        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)


        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send
            If squelchlabel.Enabled = False Then squelchlabel.Enabled = True Else squelchlabel.Enabled = False

        End If


    End Sub

    Private Sub upbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles upbtn.Click
        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 195       'SubType = execute function
        sendPkt(3) = 15


        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)


        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send

        End If
    End Sub

    Private Sub downbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles downbtn.Click
        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 195       'SubType = execute function
        sendPkt(3) = 16

        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)




        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send

        End If
    End Sub

    Private Sub chanbox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chanbox.TextChanged

    End Sub

    Private Sub volup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles volup.Click
        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 195       'SubType = execute function
        sendPkt(3) = 36

        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)




        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send

        End If
    End Sub

    Private Sub voldn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles voldn.Click
        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 195       'SubType = execute function
        sendPkt(3) = 37

        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)




        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send

        End If
    End Sub



    Private Sub radiocom_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radiocom.TextChanged







    End Sub

    Private Sub setbtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles setbtn.Click

        Try
            radiocomport = Convert.ToInt16(radiocom.Text())
        Catch ex As Exception

        End Try


        Dim ret As Byte


        SetupOptions.ComPort = radiocomport

        SetupOptions.RadioMode = PMR
        SetupOptions.DebugMode = DEBUG_ON


        ret = SETCALLBACK(0, AddressOf IncomingHandler)
        StartMap27Dll()
        SaveSetting("SRM9000", "main", "radiocomport", radiocomport)
        radiocom.Text = radiocomport

    End Sub

    Private Sub senddatacheck_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles senddatacheck.CheckedChanged

        SaveSetting("SRM9000", "main", "senddatacheck", senddatacheck.Checked)


    End Sub

    Private Sub setoutputcom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles setoutputcom.Click
        Try
            outputcomport = Convert.ToInt16(outcombox.Text())
        Catch ex As Exception

        End Try

        SaveSetting("SRM9000", "main", "outputcomport", outputcomport)
        outcombox.Text = outputcomport

        Try
            outputserialport.Close()
            outputserialport.PortName = "COM" + Convert.ToString(outputcomport)


            outputserialport.Open()
            If senddatacheck.Checked = False Then outputserialport.Close()

        Catch ex As Exception

            MsgBox("Can't open output com port")
            senddatacheck.Checked = False
        End Try


    End Sub

    Private Sub outputserialport_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles outputserialport.DataReceived

    End Sub

    Private Sub outputserialport_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles outputserialport.Disposed

    End Sub

    Private Sub outputserialport_ErrorReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialErrorReceivedEventArgs) Handles outputserialport.ErrorReceived

    End Sub



    Private Sub outputserialport_PinChanged(ByVal sender As Object, ByVal e As System.IO.Ports.SerialPinChangedEventArgs) Handles outputserialport.PinChanged
        If senddatacheck.Checked = True Then ' ROUTINE TO HANDLE PTT
            If ctsbutton.Checked Then

                If outputserialport.CtsHolding = True Then
                    PTTDOWN()
                    flag = True
                    spvoice.SpeakAsyncCancelAll()
                    ffsklabel.Enabled = False
                    If options.speechenable.Checked = True Then Timer1.Stop()


                Else
                    PTTUP()
                    flag = False
                    If options.speechenable.Checked = True Then Timer1.Start()

                End If

            End If


            If DSRbox.Checked Then
                If outputserialport.DsrHolding = True Then
                    PTTDOWN()
                    flag = True
                    spvoice.SpeakAsyncCancelAll()
                    ffsklabel.Enabled = False
                    If options.speechenable.Checked = True Then Timer1.Stop()
                Else
                    PTTUP()
                    flag = False

                    If options.speechenable.Checked = True Then Timer1.Start()


                End If

            End If


        End If
    End Sub

    Private Sub rtsbtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rtsbtn.CheckedChanged

    End Sub

    Private Sub rfpower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rfpower.Click
        Dim sendPkt(8) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values
        sendPkt(0) = 3      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 195       'SubType = execute function
        sendPkt(3) = 47

        copyOfMsg = Marshal.AllocHGlobal(8)
        Marshal.Copy(sendPkt, 0, copyOfMsg, 4)
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)




        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send

        End If
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        If WindowState = FormWindowState.Minimized Then Me.ShowInTaskbar = False


    End Sub

    Private Sub NotifyIcon1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.DoubleClick

        If WindowState = FormWindowState.Minimized Then

            Me.ShowInTaskbar = True
            WindowState = FormWindowState.Normal

        End If

    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        MsgBox("SRM9000 Controller " + vbCrLf + "Version :" & My.Application.Info.Version.ToString, MsgBoxStyle.Information, "About")



    End Sub

    Private Sub btn4800_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn4800.CheckedChanged
        gpsspeed = 4800
        gpsserialport.BaudRate = 4800
        SaveSetting("SRM9000", "main", "gpsspeed", 4800)

    End Sub

    Private Sub btn9600_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn9600.CheckedChanged
        gpsspeed = 9600
        gpsserialport.BaudRate = 9600

        SaveSetting("SRM9000", "main", "gpsspeed", 9600)
    End Sub



    Private Sub enablegps_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles enablegps.CheckedChanged


        Windows.Forms.Cursor.Current = Cursors.WaitCursor

        If enablegps.Checked = False Then


            gpsenabled = False

            gpslbl.Enabled = False

            SaveSetting("SRM9000", "main", "gpsenabled", False)

            gpsserialport.Close()
            gpslbl.BackColor = gpslblback


        Else
            Try
                gpsserialport.Open()

                gpsenabled = True

                gpslbl.Enabled = True

                SaveSetting("SRM9000", "main", "gpsenabled", True)
            Catch ex As Exception
                MsgBox("GPS Com port error", MsgBoxStyle.Critical)

                gpsenabled = False

                gpslbl.Enabled = False

                SaveSetting("SRM9000", "main", "gpsenabled", False)

                gpsserialport.Close()
                gpslbl.BackColor = gpslblback

            End Try




        End If


        Windows.Forms.Cursor.Current = Cursors.Arrow




    End Sub

    Private Sub GpsControl1_EnabledChanged(ByVal sender As Object, ByVal e As System.EventArgs)

    End Sub


    Function Convert_Degree(ByVal Decimal_Deg As Double)


        'Set degree to Integer of Argument Passed
        degrees = Fix(Decimal_Deg)

        'Set minutes to 60 times the number to the right
        'of the decimal for the variable Decimal_Deg
        minutes = (Decimal_Deg - degrees) * 100


        'Set seconds to 60 times the number to the right of the
        'decimal for the variable Minute
        seconds = Format(((minutes - Fix(minutes)) * 60), "0")
        'Returns the Result of degree conversion
        '(for example, 10.46 = 10~ 27  ' 36")

        If degrees < 0 Then degrees = degrees * -1
        If minutes < 0 Then minutes = minutes * -1
        If seconds < 0 Then seconds = seconds * -1

        Convert_Degree = " " & degrees & "° " & Fix(minutes) & "' " _
            & seconds & Chr(34)

    End Function

    Function convert_time(ByVal normaltime As String)

        Dim integertimestring As String

        integertimestring = normaltime


        hour = Mid(integertimestring, 1, 2)



        min = Mid(integertimestring, 3, 2)
        secs = Mid(integertimestring, 5, 2)
        convert_time = hour + ":" + min + ":" + secs

    End Function

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick


        If speechenabled = True Then
            saygps()

        End If





    End Sub

    Private Sub ToolsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolsToolStripMenuItem.Click
        options.ShowDialog() ' show the options dialog

        SaveSetting("SRM9000", "main", "speechenabled", speechenabled) ' save the setting
        SaveSetting("SRM9000", "main", "beacontime", beacontime)
        SaveSetting("SRM9000", "main", "pttactive", pttactive)
        SaveSetting("SRM9000", "main", "beacontext", beacontext)
        SaveSetting("SRM9000", "main", "timeout", timeout)
        SaveSetting("SRM9000", "main", "timeoutenabled", timeoutenabled)
        SaveSetting("SRM9000", "main", "gpscomport", gpscomport)
        SaveSetting("SRM9000", "main", "ffskenabled", options.ffskenabled.Checked)
        SaveSetting("SRM9000", "main", "ffsktext", options.ffsktext.Text)

    End Sub

    Private Sub saygps()
        Dim beaconspeech As String
        beaconspeech = ""

        If options.ffskenabled.Checked = True Then
            ffsklabel.Enabled = True


        End If

        If nobeacon = False Then

            PTTDOWN()

            beaconlbl.Enabled = True


            If enablegps.Checked = True Then

                If latitude.Text <> "Unavailable" Then
                    beaconspeech = latitudesp + " , " + longitudesp + ". " + timesp + ". " + altitudesp + ". " + speedsp + ". " _
                    + headingsp + ". " + satssp + ". "

                End If

            End If
            If tempenabled Then

                beaconspeech = beaconspeech + tempvoice

            End If

            beaconspeech = beaconspeech + " " + beacontext

            If beaconspeech <> "" Then spvoice.SpeakAsync(beaconspeech)
        End If


    End Sub



    Public Sub synth_SpeakCompleted(ByVal sender As Object, ByVal e As SpeakCompletedEventArgs) Handles spvoice.SpeakCompleted
        beaconlbl.Enabled = False
        If options.ffskenabled.Checked = True And flag = False Then

            sendffsk()
        End If

        If flag = False Then
            PTTUP()
        End If

        ffsklabel.Enabled = False


    End Sub









    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        saygps()
    End Sub


    Private Sub pttbutton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pttbutton.Click

    End Sub

    Private Sub timeouttimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles timeouttimer.Tick
        timeouttimer.Stop()
        PTTUP()

    End Sub


    Private Sub gpsserialport_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles gpsserialport.DataReceived






    End Sub



    Private Sub gpstimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles gpstimer.Tick

        If gpsenabled Then



            Dim data As String = gpsserialport.ReadExisting

            Dim strArr() As String = data.Split("$")
            Dim i As Integer = 0
            Dim elements As Integer
            elements = 0
            If strArr.Length > 1 Then
                elements = strArr.Length - 1
                For i = 0 To elements

                    Dim strTemp As String = strArr(i)
                    Dim lineArr() As String = strTemp.Split(",")

                    If (lineArr(0) = "GPRMC") And lineArr.Length >= 9 Then ' GPRMC sentence
                        If lineArr(2) = "A" Then ' A = OK, V = NOT OK

                            ' Latitude
                            Dim dLat As Double = Convert.ToDouble(lineArr(3))
                            dLat = dLat / 100
                            latitude.Text = Convert_Degree(dLat) + " " + lineArr(4)

                            'speech for Latitude
                            latitudesp = "I am located at latitude " + Convert.ToString(degrees) + " degrees, " + Convert.ToString(Fix(minutes)) + " minutes, " + Convert.ToString(seconds) + " seconds"
                            If lineArr(4) = "N" Then latitudesp = latitudesp + ", North" Else latitudesp = latitudesp + ", South."



                            ' Longitude
                            Dim dLon As Double = Convert.ToDouble(lineArr(5))
                            dLon = dLon / 100
                            longitude.Text = Convert_Degree(dLon) + " " + lineArr(6)

                            'speech for longitude
                            longitudesp = "Longitude " + Convert.ToString(degrees) + " degrees, " + Convert.ToString(Fix(minutes)) + " minutes, " + Convert.ToString(seconds) + " seconds"
                            If lineArr(6) = "W" Then longitudesp = longitudesp + ", West" Else longitudesp = longitudesp + ", East"




                            ' time
                            Dim dtime As String = lineArr(1)
                            time.Text = convert_time((dtime))

                            timesp = "The time is " + hour + " " + min + " and " + secs + " seconds"


                            'speed
                            Dim dspeed As String = lineArr(7)
                            Dim speedstring As String = (Convert.ToInt16(Fix(dspeed) * 1.15077945))
                            speed.Text = speedstring & " mph"
                            speedsp = "I am travelling at " + speedstring + " miles per hour"
                            'heading
                            Dim dheading As String = lineArr(8)
                            heading.Text = dheading + "°"
                            headingsp = "My heading is " + dheading + " degrees"

                            gpslbl.BackColor = Color.LightGreen



                        Else

                            latitude.Text = "Unavailable"
                            longitude.Text = "Unavailable"
                            time.Text = "Unavailable"
                            speed.Text = "Unavail"
                            heading.Text = "Unavail"
                            latitudesp = ""
                            longitudesp = ""
                            timesp = ""
                            speedsp = ""
                            headingsp = ""
                            gpslbl.BackColor = Color.Red

                        End If
                    End If


                    If (lineArr(0) = "GPGGA") And lineArr.Length >= 15 Then
                        If lineArr(6) <> "0" Then ' 1 = OK, 0 = NOT OK

                            Dim altitudestring As String = Convert.ToString(Fix(Convert.ToDouble(lineArr(9)) * 3.2808399))
                            altitudebox.Text = altitudestring & "ft"
                            altitudesp = "I am at " + altitudestring + " feet above sea level"

                            satmeter.Level = Convert.ToInt32(lineArr(7))
                            satslbl.Text = Convert.ToInt32(lineArr(7))
                            satssp = "I can see " + satslbl.Text + " navigation satellites"


                        Else

                            altitudebox.Text = "Unavail"
                            satmeter.Level = 0
                            altitudesp = ""
                            satssp = "I am unable to see any navigation satellites"


                        End If

                    End If

                Next

            End If

        End If



    End Sub


    Private Sub sendffsk()

        Dim ffsklen As Integer
        ffsklen = Len(options.ffsktext.Text)
        Dim loop2 As Integer



        Dim sendPkt(3 + ffsklen) As Byte  'Ensure large enough for sending packet
        Dim ret As Byte
        Dim copyOfMsg As IntPtr
        'sendPkt is initialised by VB to 0 so we only set non-zero values



        sendPkt(0) = 3 + ffsklen      '7 bytes to follow (1,2,3,4,5,6,7)
        sendPkt(2) = 194       'SubType = execute function
        For loop2 = 0 To ffsklen - 1
            sendPkt(3 + loop2) = Asc(Mid(options.ffsktext.Text, loop2 + 1, 1))

        Next

        copyOfMsg = Marshal.AllocHGlobal(30)
        Marshal.Copy(sendPkt, 0, copyOfMsg, sendPkt(0))
        ret = SENDRADIOMESSAGE(copyOfMsg)
        Marshal.FreeHGlobal(copyOfMsg)



        If (ret <> 1) Then '1 = send buffer is full (size is 2048 in DLL)
            'Error, unable to send

        End If




    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        sendffsk()

    End Sub



End Class
